"use strict";require("core-js/modules/es.array.iterator");Object.defineProperty(exports,"__esModule",{value:true});exports.iterate=void 0;







const iterate=function*(inputs){
if(!Array.isArray(inputs)){
throwValidation();
}

if(inputs.length===0){
return;
}

const generators=inputs.map(getGenerator);
const iterators=generators.map(getIterator);

yield*getResults(generators,iterators);
};exports.iterate=iterate;

const getGenerator=function(input){
if(Array.isArray(input)){
return function*getArray(){
yield*input;
};
}

if(typeof input!=="function"){
throwValidation();
}

return input;
};

const getIterator=function(generator){
const iterator=generator();

if(!isIterator(iterator)){
throwValidation();
}

return iterator;
};

const throwValidation=function(){
throw new TypeError("Argument must be an array of arrays or generators");
};

const isIterator=function(value){
return(
typeof value==="object"&&
value!==null&&
typeof value.next==="function");

};

const getInitialValue=function(iterator){
return iterator.next();
};

const hasEmptyIterators=function(results){
return results.some(isEmptyIterator);
};

const isEmptyIterator=function({done}){
return done;
};

const getValue=function({value}){
return value;
};

const getResults=function*(generators,iterators){
const results=iterators.map(getInitialValue);

if(hasEmptyIterators(results)){
return;
}

const result=results.map(getValue);


do{
yield result.slice();
}while(!getResult(generators,iterators,result));
};





const getResult=function(generators,iterators,result){
let reset=false;
let index=iterators.length-1;

do{
const iterator=iterators[index];

const{done,value}=iterator.next();

result[index]=value;

if(reset){
reset=false;
index--;

if(index===-1){
return true;
}
}else if(done){
reset=true;
iterators[index]=generators[index]();
}else{
break;
}
}while(true);
};
//# sourceMappingURL=iterate.js.map